local CrashSkinCheck = CrashAddon.CrashSkinCheck
local FailVibeCheck = CrashAddon.FailVibeCheck
local CootOnGround = CrashAddon.CootOnGround
local SpeedCalc = CrashAddon.SpeedCalc
local StateSetter = CrashAddon.StateSetter

//funny easter egg
local function EasterEgg(player)
	if not CrashSkinCheck(player)
		return
	end
	
	//also imma put extra visual effects for crash's super form right here
	if player.powers[pw_super] and leveltime % 5 == 0
		local crashsprks = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_IVSP)
		crashsprks.colorized = true
		crashsprks.frame = $ | FF_ADD
		crashsprks.color = SKINCOLOR_GOLDENROD
	end
	
	local crashban = player.crashban
	//this resets everything and prevents moves if crash fails the vibe check
	if FailVibeCheck(player)
		crashban.woah = false
		return
	end
	
	if (player.cmd.buttons & BT_CUSTOM3 and player.cmd.buttons & BT_TOSSFLAG) and
			CootOnGround(player.mo) and (SpeedCalc(player) == 0 or 
			P_GetPlayerControlDirection(player) == 0)
		if not crashban.woah
			S_StartSound(player.mo, sfx_woah)
			crashban.woah = true
		end
	elseif not CootOnGround(player.mo) or (SpeedCalc(player) != 0 and
			P_GetPlayerControlDirection(player) != 0) or player.cmd.buttons &
			BT_SPIN or player.cmd.buttons & BT_CUSTOM1 or player.pflags & 
			PF_SPINNING and crashban.woah
		crashban.woah = false
	end
	if crashban.woah
		StateSetter(player.mo, S_PLAY_FLY_TIRED)
	end
end

//funni feature where the tornado spin knocks back other players
local function TornadoKnockback(thing, tmthing)
	if tmthing.skin == "crashbandi" and tmthing.state == S_PLAY_SPINDASH
		if tmthing.z >= thing.z - thing.height and tmthing.z <= thing.z + 
				thing.height
			if not P_PlayerInPain(thing.player) and thing.state != S_PLAY_PAIN
				P_DoPlayerPain(thing.player)
				thing.player.powers[pw_flashing] = 0
				S_StartSound(thing, sfx_cshpew)
			end
		end
	end
end

//this makes it so crash can't grab air bubbles while super
local function NoBubbles(special, toucher)
	if toucher.skin == "crashbandi" and toucher.player.powers[pw_super]
		return true
	end
end

//hooks
addHook("PlayerThink", EasterEgg)
addHook("MobjCollide", TornadoKnockback, MT_PLAYER)