local CrashSkinCheck = CrashAddon.CrashSkinCheck
local IsNiGHTS = CrashAddon.IsNiGHTS

//debug
/*addHook("PlayerThink", function(player)
	if player.cmd.buttons & BT_TOSSFLAG and not player.powers[pw_super]
		P_DoSuperTransformation(player, true)
	end
end)*/

//this handles how Aku Aku spawns in
local function AkuSpawnAndDie(player)
	if not CrashSkinCheck(player)
		return
	end
	
	local crashban = player.crashban
	if player.playerstate == PST_DEAD and crashban.akulevel > 0
		crashban.akulevel = 0
	end
	//this adds to the aku level and removes the shield when Crash gets one
	if player.powers[pw_shield]
		//ignore shields given by both amy and adventure sonic
		//wish i have a better way of ignoring player-given shields
		if player.powers[pw_shield] != SH_PINK and player.powers[pw_shield] !=
				SH_YUSUPERSHIELD
			if not player.powers[pw_invulnerability]
				crashban.akulevel = min($ + 1, 3)
			end
			player.powers[pw_shield] = SH_NONE
		end
	end
	//this either spawns in Aku Aku or kills him based on aku level
	if not IsNiGHTS(player)
		if crashban.akulevel <= 0 and not player.powers[pw_invulnerability]
			if crashban.aku and crashban.aku.valid
				P_RemoveMobj(crashban.aku)
			end
		else
			if not crashban.aku or not crashban.aku.valid
				crashban.aku = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_AKUAKU)
				crashban.aku.target = player.mo
				S_StartSound(player.mo, sfx_akuspn)
			end
			if player.powers[pw_invulnerability]
				crashban.akulevel = 3
			end
		end
	end
end

//this determines what happens if Crash gets hit
local function CrashDamage(target, inflictor, source, damage, damagetype)
	if target.skin != "crashbandi" or IsNiGHTS(target.player)
		return
	end
	
	if target.player.crashban.akulevel <= 0
		P_KillMobj(target, inflictor, source, damagetype)
	else
		target.player.crashban.akulevel = max($ - 1, 0)
		P_PlayRinglossSound(target)
		P_DoPlayerPain(target.player, source, inflictor)
	end
	return true
end

//hooks
addHook("PlayerThink", AkuSpawnAndDie)
addHook("MobjDamage", CrashDamage, MT_PLAYER)