local IsNiGHTS = CrashAddon.IsNiGHTS

//this handles Aku Aku's behavior
local function AkuAkuThinker(mo)
	local akulevel = mo.target.player.crashban.akulevel
	//failsafe
	if akulevel == nil or mo.target == nil or not mo.target.valid or not 
			mo.target.player or IsNiGHTS(mo.target.player)
		P_RemoveMobj(mo)
		return
	end
	//this determines sound cues
	if mo.currentlevel == nil
		mo.currentlevel = akulevel
	end
	if mo.currentlevel != akulevel
		if mo.currentlevel > akulevel
			S_StartSound(mo.target, sfx_akuded)
		else
			S_StartSound(mo.target, sfx_akuspn)
		end
		mo.currentlevel = akulevel
	end
	//this makes aku aku semi-transparent if the player is in first-person
	if displayplayer == mo.target.player
		if camera.chase or (camera2 != nil and camera2.chase)
			mo.frame = $ & ~FF_TRANS80
		else
			mo.frame = $ | FF_TRANS80
		end
	end
	mo.scale = mo.target.scale
	mo.shadowscale = mo.scale - mo.scale / 4
	if mo.target.eflags & MFE_VERTICALFLIP
		mo.eflags = $ | MFE_VERTICALFLIP
	else
		mo.eflags = $ & ~MFE_VERTICALFLIP
	end
	local isSuper = mo.target.player.powers[pw_super]
	//this changes Aku Aku's color based on aku level
	if akulevel > 1
		mo.colorized = true
		if isSuper
			mo.color = mo.target.color
			mo.frame = $ | FF_FULLBRIGHT
		else
			mo.frame = $ & ~FF_FULLBRIGHT
			if leveltime % 3 == 0
				if akulevel > 2 and mo.color == SKINCOLOR_GOLDENROD
					mo.color = SKINCOLOR_SUPERGOLD2
				else
					mo.color = SKINCOLOR_GOLDENROD
				end
			end
		end
	else
		mo.colorized = false
	end
	local invincibility = mo.target.player.powers[pw_invulnerability]
	//this makes Aku Aku orbit around the player
	if akulevel < 3
		if invincibility or isSuper
			mo.target.player.crashban.akulevel = 3
		end
		mo.threshold = 40 * mo.scale
		A_UnidusBall(mo)
		A_FaceTarget(mo)
		mo.angle = $ + ANGLE_180
		//this is all the fancy visual effects
		if not (mo.frame & FF_TRANS80) and leveltime % 2 == 0
			local akughost = P_SpawnGhostMobj(mo)
			akughost.colorized = true
			akughost.frame = $ | FF_ADD
			if akulevel > 1
				akughost.color = SKINCOLOR_GOLDENROD
			else
				akughost.color = SKINCOLOR_NEON
			end
		end
		if akulevel > 1 and leveltime % 7 == 0
			local akusparks = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_IVSP)
			akusparks.colorized = true
			akusparks.frame = $ | FF_ADD | FF_TRANS70
			akusparks.color = SKINCOLOR_GOLDENROD
		end
	//this gives Crash invincibility and moves Aku Aku once max level is reached
	else
		A_ForceStop(mo)
		if not invincibility and not isSuper
			if not mo.invin
				if not isSuper
					A_Invincibility(mo)
				end
				mo.invin = true
			elseif not isSuper
				mo.invin = false
				mo.target.player.crashban.akulevel = 2
			end
		elseif not mo.invin
			mo.invin = true
		end
		local akuheight
		if mo.eflags & MFE_VERTICALFLIP
			akuheight = mo.target.height / 2 * -1 + mo.target.height / 3 + 
					mo.target.height / 10
		else
			akuheight = mo.target.height  - mo.target.height / 3 - 
					mo.target.height / 10
		end
		mo.angle = mo.target.player.drawangle
		P_MoveOrigin(mo, mo.target.x + P_ReturnThrustX(mo, mo.angle, 20 * 
				mo.scale), mo.target.y + P_ReturnThrustY(mo, mo.angle, 20 * 
				mo.scale), akuheight + mo.target.z)
		//this prevents drowning while aku aku invincibility is active
		if mo.target.eflags & MFE_UNDERWATER or mo.target.eflags & MFE_GOOWATER
			mo.target.player.powers[pw_underwater] = 30 * TICRATE
		elseif P_InSpaceSector(mo.target)
			mo.target.player.powers[pw_spacetime] = 6 * TICRATE
		end
	end
end

//hooks
addHook("MobjThinker", AkuAkuThinker, MT_AKUAKU)